Subject: Re: [PATCH] b44 1GB DMA workaround (was: b44: add 47xx support)

From: "David S. Miller" <[email-masked]>
Date: Sat, 7 Aug 2004 17:05:03 -0700

On Sun, 8 Aug 2004 01:40:19 +0300
Pekka Pietikainen <[email-masked]> wrote:

> On Tue, Aug 03, 2004 at 06:39:19PM -0700, David S. Miller wrote:
> > Changing skb->data is not legal.  Please implement this in
> > such a way that skb->data does not get modified.  By modifying
> > skb->data you will break things such as packet sniffers and
> > netfilter, and that's just the tip of the iceberg. :-)
> > 
> Haven't noticed any breakage (tm) but I'm just a x86 weenie :-)

Not an x86 specific problem :-)  Just run tcpdump in a shell when
one of these TX bounce cases happen, your skb->data modification could
will make tcpdump see a corrupt packet.

> Current approach is:
> 
>         if(1 (just for testing ;) ) || mapping+len > B44_DMA_MASK) {
>                 /* Chip can't handle DMA to/from >1GB, use bounce buffer */
>                 pci_unmap_single(bp->pdev, mapping, len,PCI_DMA_TODEVICE);
>                 memcpy(bp->tx_bufs+entry*TX_PKT_BUF_SZ,skb->data,skb->len);
>                 mapping = pci_map_single(bp->pdev,bp->tx_bufs+entry*TX_PKT_BUF_SZ, len, PCI_DMA_TODEVICE);
>         }

This looks a bit better.